<!--
 Copyright © VNG Realisatie 2023
 Licensed under the EUPL
-->

{{ define "content" }}
    <script>
        document.body.addEventListener("htmx:beforeSwap", function (evt) {
            if (
                evt.detail.xhr.status === 400 ||
                evt.detail.xhr.status === 500
            ) {
                evt.detail.shouldSwap = true;
                evt.detail.isError = false;
            }
        });
    </script>

    <p>
        <a href="/services" class="button--link"
            >{{ svg "icon-chevron-left" "icon--inline" }} {{ i18n "Back" }}</a
        >
    </p>

    <div class="add-service-page">
        {{ if ne (len .SuccessMessage) 0 }}
            <div class="alert--success">
                <p class="alert__title">{{ i18n "Success" }}</p>
                <p class="alert__content">{{ .SuccessMessage }}</p>
            </div>
        {{ end }}

        {{ if ne (len .ErrorMessages) 0 }}
            {{ block "errors" . }}
            {{ end }}
        {{ end }}


        <form
            hx-post="/services/add-service"
            hx-target="body"
            hx-swap="outerHTML"
            action="/services/add-service"
            method="post"
            autocomplete="off"
            class="add-service-page__form"
            hx-disabled-elt="button[type=submit]"
        >
            <input
                type="hidden"
                name="csrfToken"
                value="{{ .BaseAuthenticatedPage.CsrfToken }}"
            />

            <fieldset class="add-service-page__form-actions">
                <button type="submit" class="button--primary">
                    {{ i18n "Add service" }}
                </button>
            </fieldset>

            <fieldset>
                <label>
                    <span>{{ i18n "Name" }}</span>
                    <input
                        class="input--large"
                        type="text"
                        name="name"
                        value="{{ .Form.Name }}"
                        required
                        pattern="^\S+$"
                        oninvalid="nameOnInvalidHandler(this)"
                        oninput="this.setCustomValidity('')"
                    />
                </label>

                <label>
                    <span>{{ i18n "Endpoint URL" }}</span>
                    <small
                        >{{ i18n "This endpoint must be able to serve requests at the endpoint URL ending with /" }}</small
                    >
                    <input
                        class="input--large"
                        type="text"
                        name="endpointURL"
                        value="{{ .Form.EndpointURL }}"
                        required
                        pattern="^(https|http):\/\/\S+$"
                        oninvalid="endpointURLOnInvalidHandler(this)"
                        oninput="this.setCustomValidity('')"
                    />
                </label>

                <label for="inwayAddress">
                    {{ i18n "Inway" }}
                </label>
                <div class="select">
                    <select name="inwayAddress" id="inwayAddress">
                        {{ range $inwayAddress := $.InwayAddresses }}
                            <option value="{{ $inwayAddress }}">
                                {{ $inwayAddress }}
                            </option>
                        {{ end }}
                    </select>
                </div>
            </fieldset>

            <script>
                function nameOnInvalidHandler(el) {
                    if (el.validity.valueMissing) {
                        el.setCustomValidity('{{ i18n "Name of the Service is required" }}')
                    } else if (el.validity.patternMismatch) {
                        el.setCustomValidity('{{ i18n "Spaces are not allowed in the name of the Service" }}')
                    }
                }

                function endpointURLOnInvalidHandler(el) {
                    if (el.validity.valueMissing) {
                        el.setCustomValidity('{{ i18n "Endpoint URL of the Service is required" }}')
                    } else if (el.validity.patternMismatch) {
                        el.setCustomValidity('{{ i18n "Endpoint URL must be a valid URL including the http(s)" }}')
                    }
                }
            </script>
        </form>
    </div>
{{ end }}
